#region  Copyright (c) 2004 Logitech, Inc. All Rights Reserved 
/////////////////////////////////////////////////////////////////////////////////
//                                                                             //
// Copyright (c) 2004 Logitech, Inc. All Rights Reserved                       //
//                                                                             //
// This program is a trade secret of LOGITECH, and it is not to be reproduced, //
// published, disclosed to others, copied, adapted, distributed or displayed   //
// without the prior written authorization of LOGITECH.                        //
//                                                                             //
// Licensee agrees to attach or embed this notice on all copies of the program //
// including partial copies or modified versions thereof.                      //
//                                                                             //
/////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Windows.Forms;

namespace Logitech.PlugInTemplate
{
	public class ConfigurerView : System.Windows.Forms.UserControl, IConfigurerView
	{
		#region UI Definition
		#region UI Components
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label label1;
		
		private System.Windows.Forms.TextBox m_tutorTextBox;
		
		private System.ComponentModel.Container components = null;
		#endregion

		#region UI Initialization
		public ConfigurerView(ConfigurerController controller)
		{
			m_controller = controller;
			m_loaded = false;

			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfigurerView));
			this.panel1 = new System.Windows.Forms.Panel();
			this.m_tutorTextBox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.AccessibleDescription = resources.GetString("panel1.AccessibleDescription");
			this.panel1.AccessibleName = resources.GetString("panel1.AccessibleName");
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("panel1.Anchor")));
			this.panel1.AutoScroll = ((bool)(resources.GetObject("panel1.AutoScroll")));
			this.panel1.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("panel1.AutoScrollMargin")));
			this.panel1.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("panel1.AutoScrollMinSize")));
			this.panel1.BackColor = System.Drawing.SystemColors.Control;
			this.panel1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("panel1.BackgroundImage")));
			this.panel1.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("panel1.Dock")));
			this.panel1.Enabled = ((bool)(resources.GetObject("panel1.Enabled")));
			this.panel1.Font = ((System.Drawing.Font)(resources.GetObject("panel1.Font")));
			this.panel1.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("panel1.ImeMode")));
			this.panel1.Location = ((System.Drawing.Point)(resources.GetObject("panel1.Location")));
			this.panel1.Name = "panel1";
			this.panel1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("panel1.RightToLeft")));
			this.panel1.Size = ((System.Drawing.Size)(resources.GetObject("panel1.Size")));
			this.panel1.TabIndex = ((int)(resources.GetObject("panel1.TabIndex")));
			this.panel1.Text = resources.GetString("panel1.Text");
			this.panel1.Visible = ((bool)(resources.GetObject("panel1.Visible")));
			// 
			// m_tutorTextBox
			// 
			this.m_tutorTextBox.AccessibleDescription = resources.GetString("m_tutorTextBox.AccessibleDescription");
			this.m_tutorTextBox.AccessibleName = resources.GetString("m_tutorTextBox.AccessibleName");
			this.m_tutorTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tutorTextBox.Anchor")));
			this.m_tutorTextBox.AutoSize = ((bool)(resources.GetObject("m_tutorTextBox.AutoSize")));
			this.m_tutorTextBox.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tutorTextBox.BackgroundImage")));
			this.m_tutorTextBox.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tutorTextBox.Dock")));
			this.m_tutorTextBox.Enabled = ((bool)(resources.GetObject("m_tutorTextBox.Enabled")));
			this.m_tutorTextBox.Font = ((System.Drawing.Font)(resources.GetObject("m_tutorTextBox.Font")));
			this.m_tutorTextBox.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tutorTextBox.ImeMode")));
			this.m_tutorTextBox.Location = ((System.Drawing.Point)(resources.GetObject("m_tutorTextBox.Location")));
			this.m_tutorTextBox.MaxLength = ((int)(resources.GetObject("m_tutorTextBox.MaxLength")));
			this.m_tutorTextBox.Multiline = ((bool)(resources.GetObject("m_tutorTextBox.Multiline")));
			this.m_tutorTextBox.Name = "m_tutorTextBox";
			this.m_tutorTextBox.PasswordChar = ((char)(resources.GetObject("m_tutorTextBox.PasswordChar")));
			this.m_tutorTextBox.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tutorTextBox.RightToLeft")));
			this.m_tutorTextBox.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("m_tutorTextBox.ScrollBars")));
			this.m_tutorTextBox.Size = ((System.Drawing.Size)(resources.GetObject("m_tutorTextBox.Size")));
			this.m_tutorTextBox.TabIndex = ((int)(resources.GetObject("m_tutorTextBox.TabIndex")));
			this.m_tutorTextBox.Text = resources.GetString("m_tutorTextBox.Text");
			this.m_tutorTextBox.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("m_tutorTextBox.TextAlign")));
			this.m_tutorTextBox.Visible = ((bool)(resources.GetObject("m_tutorTextBox.Visible")));
			this.m_tutorTextBox.WordWrap = ((bool)(resources.GetObject("m_tutorTextBox.WordWrap")));
			this.m_tutorTextBox.TextChanged += new System.EventHandler(this.OnChanged);
			// 
			// label1
			// 
			this.label1.AccessibleDescription = resources.GetString("label1.AccessibleDescription");
			this.label1.AccessibleName = resources.GetString("label1.AccessibleName");
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("label1.Anchor")));
			this.label1.AutoSize = ((bool)(resources.GetObject("label1.AutoSize")));
			this.label1.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("label1.Dock")));
			this.label1.Enabled = ((bool)(resources.GetObject("label1.Enabled")));
			this.label1.Font = ((System.Drawing.Font)(resources.GetObject("label1.Font")));
			this.label1.Image = ((System.Drawing.Image)(resources.GetObject("label1.Image")));
			this.label1.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("label1.ImageAlign")));
			this.label1.ImageIndex = ((int)(resources.GetObject("label1.ImageIndex")));
			this.label1.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("label1.ImeMode")));
			this.label1.Location = ((System.Drawing.Point)(resources.GetObject("label1.Location")));
			this.label1.Name = "label1";
			this.label1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("label1.RightToLeft")));
			this.label1.Size = ((System.Drawing.Size)(resources.GetObject("label1.Size")));
			this.label1.TabIndex = ((int)(resources.GetObject("label1.TabIndex")));
			this.label1.Text = resources.GetString("label1.Text");
			this.label1.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("label1.TextAlign")));
			this.label1.Visible = ((bool)(resources.GetObject("label1.Visible")));
			// 
			// ConfigurerView
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AllowDrop = true;
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.label1);
			this.Controls.Add(this.m_tutorTextBox);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "ConfigurerView";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.Load += new System.EventHandler(this.ConfigurerView_Load);
			this.ResumeLayout(false);

		}

		#endregion
		#endregion

		#region IConfigurerView
		public ConfigurerModel ConfigurerModel
		{
			get
			{ 
				ConfigurerModel model = new ConfigurerModel();
				model.Tutor = m_tutorTextBox.Text; //changed
				//model.Group = Convert.ToString(m_widthTextBox.Text);
				return model;
			}

			set
			{
				m_tutorTextBox.Text = value.Tutor; //changed
				//m_widthTextBox.Text = Convert.ToString(value.Width);
			
			}
		}

		#endregion

		#region Collaborators
		ConfigurerController m_controller;
		public ConfigurerController ConfigurerController
		{
			get{return m_controller;}
		}

		bool m_loaded;
		#endregion

		#region Event Handlers
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad (e);
			m_controller.LoadFromRegistry();
			m_loaded = true;
		}

		void OnChanged(object sender, System.EventArgs e)
		{   
			if(!m_loaded) return;
			m_controller.Changed();
		}
		#endregion

		private void ConfigurerView_Load(object sender, System.EventArgs e)
		{
		
		}
	}
}
