#region  Copyright (c) 2004 Logitech, Inc. All Rights Reserved 
/////////////////////////////////////////////////////////////////////////////////
//                                                                             //
// Copyright (c) 2004 Logitech, Inc. All Rights Reserved                       //
//                                                                             //
// This program is a trade secret of LOGITECH, and it is not to be reproduced, //
// published, disclosed to others, copied, adapted, distributed or displayed   //
// without the prior written authorization of LOGITECH.                        //
//                                                                             //
// Licensee agrees to attach or embed this notice on all copies of the program //
// including partial copies or modified versions thereof.                      //
//                                                                             //
/////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Diagnostics;
using Microsoft.Win32;

namespace Logitech.PlugInTemplate
{
	public class RegistrySerializer
	{
		#region Initialization
		string m_registryRoot;
		RegistryKey m_rootRegistryKey;

		public RegistrySerializer(string registryRoot)
		{
			Debug.Assert(registryRoot != string.Empty);

			m_registryRoot = registryRoot;
			m_rootRegistryKey = Microsoft.Win32.Registry.CurrentUser;
		}
		#endregion

		#region Key Accesses
		const string PlugInRegistryRoot = @"PlugIns\PlugInTemplate\";

		//changed
		#region Tutor
		const string TutorKeyName = "Tutor";
		const string TutorDefault = "tutor@plu.ntnu.no";

		public string Tutor
		{
			get
			{
				RegistryKey subKey = m_rootRegistryKey.OpenSubKey(GetKeyRoot());
				if(subKey == null) return TutorDefault;
				string Tutor = (string)subKey.GetValue(TutorKeyName, TutorDefault);
				subKey.Close();
				return Tutor;
			}

			set
			{
				RegistryKey subKey = m_rootRegistryKey.CreateSubKey(GetKeyRoot());
				subKey.SetValue(TutorKeyName, value);
				subKey.Close();
			}
		}
		#endregion

		#region Width 
/*		const string WidthKeyName = "Width";
		const int WidthDefault = 400;

		public int Width
		{
			get
			{
				RegistryKey subKey = m_rootRegistryKey.OpenSubKey(GetKeyRoot());
				if(subKey == null) return WidthDefault;
				int width = (int)subKey.GetValue(WidthKeyName, WidthDefault);
				subKey.Close();
				return width;
			}

			set
			{
				RegistryKey subKey = m_rootRegistryKey.CreateSubKey(GetKeyRoot());
				subKey.SetValue(WidthKeyName, value);
				subKey.Close();
			}
		}

*/
		#endregion
		
		#endregion

		#region Helpers
		string GetKeyRoot()
		{
			return m_registryRoot + PlugInRegistryRoot;
		}
		string GetKeyPath(string keyName)
		{
			return GetKeyRoot() + keyName;
		}
		#endregion 
	}
}
