#region  Copyright (c) 2004 Logitech, Inc. All Rights Reserved 
/////////////////////////////////////////////////////////////////////////////////
//                                                                             //
// Copyright (c) 2004 Logitech, Inc. All Rights Reserved                       //
//                                                                             //
// This program is a trade secret of LOGITECH, and it is not to be reproduced, //
// published, disclosed to others, copied, adapted, distributed or displayed   //
// without the prior written authorization of LOGITECH.                        //
//                                                                             //
// Licensee agrees to attach or embed this notice on all copies of the program //
// including partial copies or modified versions thereof.                      //
//                                                                             //
/////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.IO;
using System.Diagnostics;

using Logitech.PlugIns;
using Logitech.Pen.Ink.Sdk;

namespace Logitech.PlugInTemplate
{
	public class PlugIn : AbstractPlugIn
	{
		#region Construction
		public PlugIn(IPlatform platform) : base(platform)
		{
		}
		#endregion

		#region Overrides
		public override void Init()
		{
			base.Init();
		}

		public override void Dispose()
		{
		}

		public override void SelectionChanged()
		{
			base.SelectionChanged ();
		}


		public override object Run(IAction action, ISelection selection, object[] parameters)
		{
			try
			{
		        String[] idList = action.Id.Split('.');

				//create the configurer 
			    if(idList[idList.GetUpperBound(0)] == "Configure")
					return ConfigurerController.Create();

				 
				StoreInFolder strfldr = new StoreInFolder(Platform);
				//strfldr will specify the directory to store in, it will set the path to ..directory..\MyIoDocuments\ +  the input name as the whole folder path
				strfldr.StoreItemInFolder(selection.SelectedItems, parameters);
			}
			catch(PlugInTemplateException pe)
			{
				Platform.LogMessage(true, pe.Message);
			}
			catch(Exception e)
			{
				Platform.LogMessage(true, e.Message);
			}

			return null;
		}
		#endregion
	}
}
